//
//	Encoder for G.729A CS-ACELP Speech Codec
// 
//		encoder.cpp : Main program for the encoder 
//

#include "StdAfx.h"
#include "encoder.h"
#include "bits.h"
#include "file_io.h"
#include "initialization.h"
#include "LP_analysis.h"
#include "pre_processing.h"
#include "open_loop.h"
#include "codebook_search.h"

int main(int argc, char* argv[])
{

	short *x_in, *y_out;

	int n;
	int freq = 0;
	int read;

	short *In, *Out;
	//unsigned char *Header;
	
	FILE *Infile=NULL, *Outfile=NULL;

	int size = 0;

	char fname[20];
	float s[240], s_p[240];
	float a[10], a_h[2][10];
	float q[2][10];
	float q_sf[2][10];
	float w[10];
	int i;
	int start;
	int current;
	int frame;

	int head=0;
	float r[80], h[80], x[80];
	float s_w[320];
	float ew[10];
	int T_op;
	bool P0;
	int P1, P2;
	float g_p1=0.8, g_p2=0.8;
	float v[80], u[240], y[80], c[80], z[80];
	int S1, S2, C1, C2;
	float g_c1 = 5.5847, g_c2;
	float U_h[4] = {-14.0, -14.0, -14.0, -14.0};

	short test2[80];
	float test[90];
	for (i=0; i<90; i++)
		test[i] = 0;


	FILE *fout2; 

	char foname[NUM_FILE][FILE_NAME_SIZE];
	strcpy(foname[0],"original.dat");
	strcpy(foname[1],"pre_processed_before_lowpass.dat");
	strcpy(foname[2],"pre_processed_after_lowpass.dat");
	strcpy(foname[3],"autocorrelate_func_before_BWE.dat");
	strcpy(foname[4],"autocorrelate_func_after_BWE.dat");
	strcpy(foname[5],"LP_synthesis.dat");
	strcpy(foname[6],"LSF.dat");

	FILE *fout[NUM_FILE];

	fout2 = fopen("coded_parameter.dat","wb");
/*
	for (i=0; i<=6; i++)
		fout[i] = fopen(foname[i],"w");
*/
	if (argc != 2)
	{
		printf("\nA program to encode a 8kHz, 16-bit PCM wave file using CS-ACELP");
		printf("\nUsage: encoder [input wave file]");
	}
	else
	{
		strcpy(fname, argv[1]);

		//Opening input and output file
		if ((Infile = fopen(fname, "rb")) == NULL)
		{
			printf("Error opening the input wave file\n");		
			exit(-1);
		}
/*		
		else if ((Outfile = fopen("output.out", "wb")) == NULL)
		{
			printf("Error opening file for writing\n");
			fclose(Infile);
			exit(-1);
		}
		fclose(Outfile);
*/			
		checkHeader(Infile);

		FILE *Outtest;
		int fileLen = 0;
		Outtest = fopen("r_speech.wav","wb");
		createHeader(Outtest);

		Outfile = fopen("parameter.txt","w");
		fclose(Outfile);

		//Allocate and initialize the memory
//		x_in = (short *)malloc(BUFFERSIZE);
//		y_out = (short *)malloc(BUFFERSIZE);
		short x_in[BUFFERSIZE];
		short y_out[BUFFERSIZE];

		for (n=0;n<BUFFERSIZE;n++)
		{
			x_in[n] = 0;
			y_out[n] = 0;
		}
    	for (i=0; i<6*SUBFRAMESIZE; i++)		
		{
			s[i] = 0;
			u[i] = 0;
		}
			
		for (n=0; n<10; n++)
			ew[n] = 0;
		for (n=0; n<80; n++)
			r[n] = 0;

		start = 3*SUBFRAMESIZE;

		current = 0;
		initialize(q[current]);

		//Read in the initial frame
		fread(&x_in[start], sizeof(short), SUBFRAMESIZE, Infile);
		preprocessing(y_out, x_in, start, SUBFRAMESIZE);
		frame = 0;			
		for (i=0; i<SUBFRAMESIZE; i++)
			s[start+i] = (float)y_out[start+i];

		start = 4*SUBFRAMESIZE;

		while((read = fread(&x_in[start], sizeof(short), FRAMESIZE, Infile))==FRAMESIZE)
		{
			preprocessing(y_out, x_in, start, FRAMESIZE);
			frame++;			

			for (i=0; i<FRAMESIZE; i++)
				s[start+i] = (float)y_out[start+i];
			window_and_autocorrelate(s,start,s_p,a,fout);

			current = 1 - current;
			LP2LSP(a,w,q[current],fout);
			interpolate_LSP(q, current, q_sf);
			LSP2LP(q_sf[0], a_h[0]);
			LSP2LP(q_sf[1], a_h[1]);	
			
			// Ching-Kai's part
			perceptual_weighting(s, a_h[0], (start-SUBFRAMESIZE)%240, head, &r[0], s_w, ew);
			perceptual_weighting(s, a_h[1], start%240, (head+SUBFRAMESIZE)%320, &r[40], s_w, ew);
			open_loop_pitch_analysis(s_w, head, &T_op);
/*
			response(a_h[0], &r[0], &h[0], &x[0], ew);
			response(a_h[1], &r[40], &h[40], &x[40], ew);
*/
			// Howard's part
			codebook_search(a_h, x, h, u, r, T_op, &P0, &P1, &P2, &g_p1, &g_p2, v, y, z, &S1, &S2, &C1, &C2, c, &g_c1, &g_c2, U_h, ew);

			WriteToFile(w, P0, P1, P2, C1, S1, C2, S2, g_p1, g_c1, g_p2, g_c2, fout2);

//			n   = (n+FRAMESIZE)%BUFFERSIZE;
//			Outfile = fopen("output.out", "ab");
//			fwrite(Out, sizeof(short), FRAMESIZE, Outfile);
//			fclose(Outfile);
//			In  = x_in + n;
//			Out = y_out + n;
/*

			float temp1, temp2;
			for (n=0, temp1=0, temp2=0; n<40; n++)
			{
				temp1 += s[(start+n)%240]-u[n+80]+g_c1*c[n];
				temp2 += c[n]*c[n];
			}			
*/
			for (n=0; n<40; n++)
				for (i=1, test[n+10]=u[n+80]/*+(temp1/temp2-g_c1)*c[n]*/; i<=10; i++)
					test[n+10] -= a_h[0][i-1]*test[n-i+10];
/*
			for (n=40, temp1=0, temp2=0; n<80; n++)
			{
				temp1 += s[(start+n)%240]-u[n+80]+g_c1*c[n];
				temp2 += c[n]*c[n];
			}			
*/
			for (n=40; n<80; n++)
				for (i=1, test[n+10]=u[n+80]/*+(temp1/temp2-g_c2)*c[n]*/; i<=10; i++)
					test[n+10] -= a_h[1][i-1]*test[n-i+10];

			for (n=0; n<10; n++)
				test[n] = test[n+80];

			for (n=0; n<80; n++)
				test2[n] = (short) test[n+10];

			fileLen += fwrite(test2, sizeof(short), FRAMESIZE , Outtest);


			start = (start+FRAMESIZE)%240;
			head = (head + FRAMESIZE)%320;

		}

		preprocessing(y_out, x_in, start, read);
		frame++;		

//		start = (start+FRAMESIZE)%240;
		for (i=0; i<read; i++)
			s[(start+i)%240] = (float)y_out[(start+i)%BUFFERSIZE];
		for (i=read; i<FRAMESIZE; i++)
			s[(start+i)%240] = 0;
		window_and_autocorrelate(s,start,s_p,a,fout);
		current = 1 - current;
		LP2LSP(a,w,q[current],fout);
		interpolate_LSP(q, current, q_sf);
		LSP2LP(q_sf[0], a_h[0]);
		LSP2LP(q_sf[1], a_h[1]);

		// Ching-Kai's part
		perceptual_weighting(s, a_h[0], (start-SUBFRAMESIZE)%240, head, &r[0], s_w, ew);
		perceptual_weighting(s, a_h[1], (start)%240, (head+SUBFRAMESIZE)%320, &r[40], s_w, ew);
		open_loop_pitch_analysis(s_w, head, &T_op);
		head = (head + FRAMESIZE)%320;

		// Howard's part
		codebook_search(a_h, x, h, u, r, T_op, &P0, &P1, &P2, &g_p1, &g_p2, v, y, z, &S1, &S2, &C1, &C2, c, &g_c1, &g_c2, U_h, ew);

		WriteToFile(w, P0, P1, P2, C1, S1, C2, S2, g_p1, g_c1, g_p2, g_c2, fout2);
		
		printf("number of frames = %d\n", frame);
		printf("The encoder input is the wave file %s\n",fname);
		printf("The encoder output is the file: coded_parameter.dat \n");
		//printf("  1) output.out  [The preprocessed signal]\n");
		//printf("  2) LSF.dat     [The Line Spectral Frequencies of each frame]\n");
		//printf("All other data files are created for the Matlab demo\n");
//		n   = (n+read)%BUFFERSIZE;
//		Outfile = fopen("output.out", "ab");
//		fwrite(Out, sizeof(short), read, Outfile);
//		fclose(Outfile);
	writeFilesize(Outtest, fileLen);
	fclose(Outtest);
		
		fclose(Infile);
/*
		for (i=0; i<=6; i++)
			fclose(fout[i]);
*/	}

	fclose(fout2);
	
	return 0;
}